{***************************************************************************}
{ TMS LCL HW components for Raspberry Pi                                    }
{ for Lazarus                                                               }
{                                                                           }
{ written by TMS Software                                                   }
{            copyright © 2015 - 2016                                        }
{            Email : info@tmssoftware.com                                   }
{            Web : http://www.tmssoftware.com                               }
{                                                                           }
{ The source code is given as is. The author is not responsible             }
{ for any possible damage done due to the use of this code.                 }
{ The component can be freely used in any application. The complete         }
{ source code remains property of the author and may not be distributed,    }
{ published, given or sold in any form as such. No parts of the source      }
{ code can be included in any other component or application without        }
{ written authorization of the author.                                      }
{***************************************************************************}

unit TMSLCLRaspiFonts;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

var
   font_table : array[0..256 * 5 - 1] of byte  = (
	 $00,  $00,  $00,  $00,  $00,
	 $3E,  $5B,  $4F,  $5B,  $3E,
	 $3E,  $6B,  $4F,  $6B,  $3E,
	 $1C,  $3E,  $7C,  $3E,  $1C,
	 $18,  $3C,  $7E,  $3C,  $18,
	 $1C,  $57,  $7D,  $57,  $1C,
	 $1C,  $5E,  $7F,  $5E,  $1C,
	 $00,  $18,  $3C,  $18,  $00,
	 $FF,  $E7,  $C3,  $E7,  $FF,
	 $00,  $18,  $24,  $18,  $00,
	 $FF,  $E7,  $DB,  $E7,  $FF,
	 $30,  $48,  $3A,  $06,  $0E,
	 $26,  $29,  $79,  $29,  $26,
	 $40,  $7F,  $05,  $05,  $07,
	 $40,  $7F,  $05,  $25,  $3F,
	 $5A,  $3C,  $E7,  $3C,  $5A,
	 $7F,  $3E,  $1C,  $1C,  $08,
	 $08,  $1C,  $1C,  $3E,  $7F,
	 $14,  $22,  $7F,  $22,  $14,
	 $5F,  $5F,  $00,  $5F,  $5F,
	 $06,  $09,  $7F,  $01,  $7F,
	 $00,  $66,  $89,  $95,  $6A,
	 $60,  $60,  $60,  $60,  $60,
	 $94,  $A2,  $FF,  $A2,  $94,
	 $08,  $04,  $7E,  $04,  $08,
	 $10,  $20,  $7E,  $20,  $10,
	 $08,  $08,  $2A,  $1C,  $08,
	 $08,  $1C,  $2A,  $08,  $08,
	 $1E,  $10,  $10,  $10,  $10,
	 $0C,  $1E,  $0C,  $1E,  $0C,
	 $30,  $38,  $3E,  $38,  $30,
	 $06,  $0E,  $3E,  $0E,  $06,
	 $00,  $00,  $00,  $00,  $00,
	 $00,  $00,  $5F,  $00,  $00,
	 $00,  $07,  $00,  $07,  $00,
	 $14,  $7F,  $14,  $7F,  $14,
	 $24,  $2A,  $7F,  $2A,  $12,
	 $23,  $13,  $08,  $64,  $62,
	 $36,  $49,  $56,  $20,  $50,
	 $00,  $08,  $07,  $03,  $00,
	 $00,  $1C,  $22,  $41,  $00,
	 $00,  $41,  $22,  $1C,  $00,
	 $2A,  $1C,  $7F,  $1C,  $2A,
	 $08,  $08,  $3E,  $08,  $08,
	 $00,  $80,  $70,  $30,  $00,
	 $08,  $08,  $08,  $08,  $08,
	 $00,  $00,  $60,  $60,  $00,
	 $20,  $10,  $08,  $04,  $02,
	 $3E,  $51,  $49,  $45,  $3E,
	 $00,  $42,  $7F,  $40,  $00,
	 $72,  $49,  $49,  $49,  $46,
	 $21,  $41,  $49,  $4D,  $33,
	 $18,  $14,  $12,  $7F,  $10,
	 $27,  $45,  $45,  $45,  $39,
	 $3C,  $4A,  $49,  $49,  $31,
	 $41,  $21,  $11,  $09,  $07,
	 $36,  $49,  $49,  $49,  $36,
	 $46,  $49,  $49,  $29,  $1E,
	 $00,  $00,  $14,  $00,  $00,
	 $00,  $40,  $34,  $00,  $00,
	 $00,  $08,  $14,  $22,  $41,
	 $14,  $14,  $14,  $14,  $14,
	 $00,  $41,  $22,  $14,  $08,
	 $02,  $01,  $59,  $09,  $06,
	 $3E,  $41,  $5D,  $59,  $4E,
	 $7C,  $12,  $11,  $12,  $7C,
	 $7F,  $49,  $49,  $49,  $36,
	 $3E,  $41,  $41,  $41,  $22,
	 $7F,  $41,  $41,  $41,  $3E,
	 $7F,  $49,  $49,  $49,  $41,
	 $7F,  $09,  $09,  $09,  $01,
	 $3E,  $41,  $41,  $51,  $73,
	 $7F,  $08,  $08,  $08,  $7F,
	 $00,  $41,  $7F,  $41,  $00,
	 $20,  $40,  $41,  $3F,  $01,
	 $7F,  $08,  $14,  $22,  $41,
	 $7F,  $40,  $40,  $40,  $40,
	 $7F,  $02,  $1C,  $02,  $7F,
	 $7F,  $04,  $08,  $10,  $7F,
	 $3E,  $41,  $41,  $41,  $3E,
	 $7F,  $09,  $09,  $09,  $06,
	 $3E,  $41,  $51,  $21,  $5E,
	 $7F,  $09,  $19,  $29,  $46,
	 $26,  $49,  $49,  $49,  $32,
	 $03,  $01,  $7F,  $01,  $03,
	 $3F,  $40,  $40,  $40,  $3F,
	 $1F,  $20,  $40,  $20,  $1F,
	 $3F,  $40,  $38,  $40,  $3F,
	 $63,  $14,  $08,  $14,  $63,
	 $03,  $04,  $78,  $04,  $03,
	 $61,  $59,  $49,  $4D,  $43,
	 $00,  $7F,  $41,  $41,  $41,
	 $02,  $04,  $08,  $10,  $20,
	 $00,  $41,  $41,  $41,  $7F,
	 $04,  $02,  $01,  $02,  $04,
	 $40,  $40,  $40,  $40,  $40,
	 $00,  $03,  $07,  $08,  $00,
	 $20,  $54,  $54,  $78,  $40,
	 $7F,  $28,  $44,  $44,  $38,
	 $38,  $44,  $44,  $44,  $28,
	 $38,  $44,  $44,  $28,  $7F,
	 $38,  $54,  $54,  $54,  $18,
	 $00,  $08,  $7E,  $09,  $02,
	 $18,  $A4,  $A4,  $9C,  $78,
	 $7F,  $08,  $04,  $04,  $78,
	 $00,  $44,  $7D,  $40,  $00,
	 $20,  $40,  $40,  $3D,  $00,
	 $7F,  $10,  $28,  $44,  $00,
	 $00,  $41,  $7F,  $40,  $00,
	 $7C,  $04,  $78,  $04,  $78,
	 $7C,  $08,  $04,  $04,  $78,
	 $38,  $44,  $44,  $44,  $38,
	 $FC,  $18,  $24,  $24,  $18,
	 $18,  $24,  $24,  $18,  $FC,
	 $7C,  $08,  $04,  $04,  $08,
	 $48,  $54,  $54,  $54,  $24,
	 $04,  $04,  $3F,  $44,  $24,
	 $3C,  $40,  $40,  $20,  $7C,
	 $1C,  $20,  $40,  $20,  $1C,
	 $3C,  $40,  $30,  $40,  $3C,
	 $44,  $28,  $10,  $28,  $44,
	 $4C,  $90,  $90,  $90,  $7C,
	 $44,  $64,  $54,  $4C,  $44,
	 $00,  $08,  $36,  $41,  $00,
	 $00,  $00,  $77,  $00,  $00,
	 $00,  $41,  $36,  $08,  $00,
	 $02,  $01,  $02,  $04,  $02,
	 $3C,  $26,  $23,  $26,  $3C,
	 $1E,  $A1,  $A1,  $61,  $12,
	 $3A,  $40,  $40,  $20,  $7A,
	 $38,  $54,  $54,  $55,  $59,
	 $21,  $55,  $55,  $79,  $41,
	 $22,  $54,  $54,  $78,  $42, // a-umlaut
	 $21,  $55,  $54,  $78,  $40,
	 $20,  $54,  $55,  $79,  $40,
	 $0C,  $1E,  $52,  $72,  $12,
	 $39,  $55,  $55,  $55,  $59,
	 $39,  $54,  $54,  $54,  $59,
	 $39,  $55,  $54,  $54,  $58,
	 $00,  $00,  $45,  $7C,  $41,
	 $00,  $02,  $45,  $7D,  $42,
	 $00,  $01,  $45,  $7C,  $40,
	 $7D,  $12,  $11,  $12,  $7D, // A-umlaut
	 $F0,  $28,  $25,  $28,  $F0,
	 $7C,  $54,  $55,  $45,  $00,
	 $20,  $54,  $54,  $7C,  $54,
	 $7C,  $0A,  $09,  $7F,  $49,
	 $32,  $49,  $49,  $49,  $32,
	 $3A,  $44,  $44,  $44,  $3A, // o-umlaut
	 $32,  $4A,  $48,  $48,  $30,
	 $3A,  $41,  $41,  $21,  $7A,
	 $3A,  $42,  $40,  $20,  $78,
	 $00,  $9D,  $A0,  $A0,  $7D,
	 $3D,  $42,  $42,  $42,  $3D, // O-umlaut
	 $3D,  $40,  $40,  $40,  $3D,
	 $3C,  $24,  $FF,  $24,  $24,
	 $48,  $7E,  $49,  $43,  $66,
	 $2B,  $2F,  $FC,  $2F,  $2B,
	 $FF,  $09,  $29,  $F6,  $20,
	 $C0,  $88,  $7E,  $09,  $03,
	 $20,  $54,  $54,  $79,  $41,
	 $00,  $00,  $44,  $7D,  $41,
	 $30,  $48,  $48,  $4A,  $32,
	 $38,  $40,  $40,  $22,  $7A,
	 $00,  $7A,  $0A,  $0A,  $72,
	 $7D,  $0D,  $19,  $31,  $7D,
	 $26,  $29,  $29,  $2F,  $28,
	 $26,  $29,  $29,  $29,  $26,
	 $30,  $48,  $4D,  $40,  $20,
	 $38,  $08,  $08,  $08,  $08,
	 $08,  $08,  $08,  $08,  $38,
	 $2F,  $10,  $C8,  $AC,  $BA,
	 $2F,  $10,  $28,  $34,  $FA,
	 $00,  $00,  $7B,  $00,  $00,
	 $08,  $14,  $2A,  $14,  $22,
	 $22,  $14,  $2A,  $14,  $08,
	 $55,  $00,  $55,  $00,  $55, // #176 (25% block) missing in old code
	 $AA,  $55,  $AA,  $55,  $AA, // 50% block
	 $FF,  $55,  $FF,  $55,  $FF, // 75% block
	 $00,  $00,  $00,  $FF,  $00,
	 $10,  $10,  $10,  $FF,  $00,
	 $14,  $14,  $14,  $FF,  $00,
	 $10,  $10,  $FF,  $00,  $FF,
	 $10,  $10,  $F0,  $10,  $F0,
	 $14,  $14,  $14,  $FC,  $00,
	 $14,  $14,  $F7,  $00,  $FF,
	 $00,  $00,  $FF,  $00,  $FF,
	 $14,  $14,  $F4,  $04,  $FC,
	 $14,  $14,  $17,  $10,  $1F,
	 $10,  $10,  $1F,  $10,  $1F,
	 $14,  $14,  $14,  $1F,  $00,
	 $10,  $10,  $10,  $F0,  $00,
	 $00,  $00,  $00,  $1F,  $10,
	 $10,  $10,  $10,  $1F,  $10,
	 $10,  $10,  $10,  $F0,  $10,
	 $00,  $00,  $00,  $FF,  $10,
	 $10,  $10,  $10,  $10,  $10,
	 $10,  $10,  $10,  $FF,  $10,
	 $00,  $00,  $00,  $FF,  $14,
	 $00,  $00,  $FF,  $00,  $FF,
	 $00,  $00,  $1F,  $10,  $17,
	 $00,  $00,  $FC,  $04,  $F4,
	 $14,  $14,  $17,  $10,  $17,
	 $14,  $14,  $F4,  $04,  $F4,
	 $00,  $00,  $FF,  $00,  $F7,
	 $14,  $14,  $14,  $14,  $14,
	 $14,  $14,  $F7,  $00,  $F7,
	 $14,  $14,  $14,  $17,  $14,
	 $10,  $10,  $1F,  $10,  $1F,
	 $14,  $14,  $14,  $F4,  $14,
	 $10,  $10,  $F0,  $10,  $F0,
	 $00,  $00,  $1F,  $10,  $1F,
	 $00,  $00,  $00,  $1F,  $14,
	 $00,  $00,  $00,  $FC,  $14,
	 $00,  $00,  $F0,  $10,  $F0,
	 $10,  $10,  $FF,  $10,  $FF,
	 $14,  $14,  $14,  $FF,  $14,
	 $10,  $10,  $10,  $1F,  $00,
	 $00,  $00,  $00,  $F0,  $10,
	 $FF,  $FF,  $FF,  $FF,  $FF,
	 $F0,  $F0,  $F0,  $F0,  $F0,
	 $FF,  $FF,  $FF,  $00,  $00,
	 $00,  $00,  $00,  $FF,  $FF,
	 $0F,  $0F,  $0F,  $0F,  $0F,
	 $38,  $44,  $44,  $38,  $44,
	 $FC,  $4A,  $4A,  $4A,  $34, // sharp-s or beta
	 $7E,  $02,  $02,  $06,  $06,
	 $02,  $7E,  $02,  $7E,  $02,
	 $63,  $55,  $49,  $41,  $63,
	 $38,  $44,  $44,  $3C,  $04,
	 $40,  $7E,  $20,  $1E,  $20,
	 $06,  $02,  $7E,  $02,  $02,
	 $99,  $A5,  $E7,  $A5,  $99,
	 $1C,  $2A,  $49,  $2A,  $1C,
	 $4C,  $72,  $01,  $72,  $4C,
	 $30,  $4A,  $4D,  $4D,  $30,
	 $30,  $48,  $78,  $48,  $30,
	 $BC,  $62,  $5A,  $46,  $3D,
	 $3E,  $49,  $49,  $49,  $00,
	 $7E,  $01,  $01,  $01,  $7E,
	 $2A,  $2A,  $2A,  $2A,  $2A,
	 $44,  $44,  $5F,  $44,  $44,
	 $40,  $51,  $4A,  $44,  $40,
	 $40,  $44,  $4A,  $51,  $40,
	 $00,  $00,  $FF,  $01,  $03,
	 $E0,  $80,  $FF,  $00,  $00,
	 $08,  $08,  $6B,  $6B,  $08,
	 $36,  $12,  $36,  $24,  $36,
	 $06,  $0F,  $09,  $0F,  $06,
	 $00,  $00,  $18,  $18,  $00,
	 $00,  $00,  $10,  $10,  $00,
	 $30,  $40,  $FF,  $01,  $01,
	 $00,  $1F,  $01,  $01,  $1E,
	 $00,  $19,  $1D,  $17,  $12,
	 $00,  $3C,  $3C,  $3C,  $3C,
	 $00,  $00,  $00,  $00,  $00  // #255 NBSP
        );

   font_table_large : array[0..256 * 24 * 2 - 1] of byte = (

       // code=0, hex=0x00, ascii="^@"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       // code=1, hex=$01, ascii="^A"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $20,$10,  // 001000000001
       $20,$10,  // 001000000001
       $2C,$D0,  // 001011001101
       $2C,$D0,  // 001011001101
       $20,$10,  // 001000000001
       $20,$10,  // 001000000001
       $20,$10,  // 001000000001
       $2C,$D0,  // 001011001101
       $27,$90,  // 001001111001
       $23,$10,  // 001000110001
       $20,$10,  // 001000000001
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       // code=2, hex=$02, ascii="^B"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1F,$E0,  // 000111111110
       $3F,$F0,  // 001111111111
       $3F,$F0,  // 001111111111
       $3F,$F0,  // 001111111111
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $3F,$F0,  // 001111111111
       $3F,$F0,  // 001111111111
       $3F,$F0,  // 001111111111
       $33,$30,  // 001100110011
       $38,$70,  // 001110000111
       $3C,$F0,  // 001111001111
       $3F,$F0,  // 001111111111
       $3F,$F0,  // 001111111111
       $1F,$E0,  // 000111111110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=3, hex=$03, ascii="^C"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $08,$40,  // 000010000100
       $1C,$E0,  // 000111001110
       $3F,$F0,  // 001111111111
       $3F,$F0,  // 001111111111
       $3F,$F0,  // 001111111111
       $3F,$F0,  // 001111111111
       $1F,$E0,  // 000111111110
       $1F,$E0,  // 000111111110
       $1F,$E0,  // 000111111110
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=4, hex=$04, ascii="^D"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $1F,$E0,  // 000111111110
       $1F,$E0,  // 000111111110
       $3F,$F0,  // 001111111111
       $1F,$E0,  // 000111111110
       $1F,$E0,  // 000111111110
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=5, hex=$05, ascii="^E"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $07,$80,  // 000001111000
       $03,$00,  // 000000110000
       $1B,$60,  // 000110110110
       $3F,$F0,  // 001111111111
       $3F,$F0,  // 001111111111
       $3F,$F0,  // 001111111111
       $1B,$60,  // 000110110110
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $0F,$C0,  // 000011111100
       $1F,$E0,  // 000111111110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=6, hex=$06, ascii="^F"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $1F,$E0,  // 000111111110
       $3F,$F0,  // 001111111111
       $3F,$F0,  // 001111111111
       $3F,$F0,  // 001111111111
       $1F,$E0,  // 000111111110
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $0F,$C0,  // 000011111100
       $1F,$E0,  // 000111111110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=7, hex=$07, ascii="^G"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $07,$80,  // 000001111000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=8, hex=$08, ascii="^H"

       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FC,$F0,  // 111111001111
       $F8,$70,  // 111110000111
       $F0,$30,  // 111100000011
       $F0,$30,  // 111100000011
       $F8,$70,  // 111110000111
       $FC,$F0,  // 111111001111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111

       //
        // code=9, hex=$09, ascii="^I"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $0C,$C0,  // 000011001100
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=10, hex=$0A, ascii="^J"

       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $F8,$70,  // 111110000111
       $F3,$30,  // 111100110011
       $E7,$90,  // 111001111001
       $E7,$90,  // 111001111001
       $F3,$30,  // 111100110011
       $F8,$70,  // 111110000111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111

       //
        // code=11, hex=$0B, ascii="^K"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$F0,  // 000000111111
       $00,$70,  // 000000000111
       $00,$F0,  // 000000001111
       $01,$B0,  // 000000011011
       $03,$30,  // 000000110011
       $06,$00,  // 000001100000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=12, hex=$0C, ascii="^L"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $1F,$E0,  // 000111111110
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=13, hex=$0D, ascii="^M"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0E,$00,  // 000011100000
       $0F,$00,  // 000011110000
       $0D,$80,  // 000011011000
       $0C,$C0,  // 000011001100
       $0C,$60,  // 000011000110
       $0C,$60,  // 000011000110
       $0C,$60,  // 000011000110
       $0C,$60,  // 000011000110
       $0C,$C0,  // 000011001100
       $0F,$80,  // 000011111000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $3C,$00,  // 001111000000
       $3C,$00,  // 001111000000
       $38,$00,  // 001110000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=14, hex=$0E, ascii="^N"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0F,$F0,  // 000011111111
       $0C,$30,  // 000011000011
       $0F,$F0,  // 000011111111
       $0C,$30,  // 000011000011
       $0C,$30,  // 000011000011
       $0C,$30,  // 000011000011
       $0C,$30,  // 000011000011
       $0C,$30,  // 000011000011
       $0C,$30,  // 000011000011
       $0C,$30,  // 000011000011
       $0C,$30,  // 000011000011
       $0C,$30,  // 000011000011
       $0C,$30,  // 000011000011
       $0C,$F0,  // 000011001111
       $3C,$F0,  // 001111001111
       $3C,$E0,  // 001111001110
       $38,$00,  // 001110000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=15, hex=$0F, ascii="^O"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $33,$30,  // 001100110011
       $1F,$E0,  // 000111111110
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $38,$70,  // 001110000111
       $18,$60,  // 000110000110
       $0C,$C0,  // 000011001100
       $1F,$E0,  // 000111111110
       $33,$30,  // 001100110011
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=16, hex=$10, ascii="^P"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$00,  // 001100000000
       $38,$00,  // 001110000000
       $3C,$00,  // 001111000000
       $3E,$00,  // 001111100000
       $3F,$00,  // 001111110000
       $3F,$80,  // 001111111000
       $3F,$C0,  // 001111111100
       $3F,$E0,  // 001111111110
       $3F,$F0,  // 001111111111
       $3F,$E0,  // 001111111110
       $3F,$C0,  // 001111111100
       $3F,$80,  // 001111111000
       $3F,$00,  // 001111110000
       $3E,$00,  // 001111100000
       $3C,$00,  // 001111000000
       $38,$00,  // 001110000000
       $30,$00,  // 001100000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=17, hex=$11, ascii="^Q"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$30,  // 000000000011
       $00,$70,  // 000000000111
       $00,$F0,  // 000000001111
       $01,$F0,  // 000000011111
       $03,$F0,  // 000000111111
       $07,$F0,  // 000001111111
       $0F,$F0,  // 000011111111
       $1F,$F0,  // 000111111111
       $3F,$F0,  // 001111111111
       $1F,$F0,  // 000111111111
       $0F,$F0,  // 000011111111
       $07,$F0,  // 000001111111
       $03,$F0,  // 000000111111
       $01,$F0,  // 000000011111
       $00,$F0,  // 000000001111
       $00,$70,  // 000000000111
       $00,$30,  // 000000000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=18, hex=$12, ascii="^R"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $01,$80,  // 000000011000
       $03,$C0,  // 000000111100
       $07,$E0,  // 000001111110
       $0F,$F0,  // 000011111111
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $0F,$F0,  // 000011111111
       $07,$E0,  // 000001111110
       $03,$C0,  // 000000111100
       $01,$80,  // 000000011000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=19, hex=$13, ascii="^S"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=20, hex=$14, ascii="^T"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$F0,  // 000001111111
       $1D,$B0,  // 000111011011
       $39,$B0,  // 001110011011
       $31,$B0,  // 001100011011
       $31,$B0,  // 001100011011
       $31,$B0,  // 001100011011
       $19,$B0,  // 000110011011
       $1D,$B0,  // 000111011011
       $07,$B0,  // 000001111011
       $01,$B0,  // 000000011011
       $01,$B0,  // 000000011011
       $01,$B0,  // 000000011011
       $01,$B0,  // 000000011011
       $01,$B0,  // 000000011011
       $01,$B0,  // 000000011011
       $01,$B0,  // 000000011011
       $01,$B0,  // 000000011011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=21, hex=$15, ascii="^U"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$00,  // 001100000000
       $1F,$80,  // 000111111000
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $0C,$C0,  // 000011001100
       $07,$E0,  // 000001111110
       $00,$30,  // 000000000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=22, hex=$16, ascii="^V"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $1F,$F0,  // 000111111111
       $1F,$F0,  // 000111111111
       $1F,$F0,  // 000111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=23, hex=$17, ascii="^W"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $0F,$C0,  // 000011111100
       $1F,$E0,  // 000111111110
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $1F,$E0,  // 000111111110
       $0F,$C0,  // 000011111100
       $07,$80,  // 000001111000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=24, hex=$18, ascii="^X"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $01,$80,  // 000000011000
       $03,$C0,  // 000000111100
       $07,$E0,  // 000001111110
       $0F,$F0,  // 000011111111
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=25, hex=$19, ascii="^Y"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $0F,$F0,  // 000011111111
       $07,$E0,  // 000001111110
       $03,$C0,  // 000000111100
       $01,$80,  // 000000011000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=26, hex=$1A, ascii="^Z"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $01,$80,  // 000000011000
       $00,$C0,  // 000000001100
       $00,$60,  // 000000000110
       $3F,$F0,  // 001111111111
       $00,$60,  // 000000000110
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=27, hex=$1B, ascii="^["

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $18,$00,  // 000110000000
       $3F,$F0,  // 001111111111
       $18,$00,  // 000110000000
       $0C,$00,  // 000011000000
       $06,$00,  // 000001100000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=28, hex=$1C, ascii="^\"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $0F,$F0,  // 000011111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=29, hex=$1D, ascii="^]"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $04,$80,  // 000001001000
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $3F,$F0,  // 001111111111
       $18,$60,  // 000110000110
       $0C,$C0,  // 000011001100
       $04,$80,  // 000001001000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=30, hex=$1E, ascii="^^"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $1F,$E0,  // 000111111110
       $1F,$E0,  // 000111111110
       $1F,$E0,  // 000111111110
       $1F,$E0,  // 000111111110
       $3F,$F0,  // 001111111111
       $3F,$F0,  // 001111111111
       $3F,$F0,  // 001111111111
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=31, hex=$1F, ascii="^_"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $3F,$F0,  // 001111111111
       $3F,$F0,  // 001111111111
       $3F,$F0,  // 001111111111
       $1F,$E0,  // 000111111110
       $1F,$E0,  // 000111111110
       $1F,$E0,  // 000111111110
       $1F,$E0,  // 000111111110
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=32, hex=$20, ascii=" "

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=33, hex=$21, ascii="!"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=34, hex=$22, ascii="""

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=35, hex=$23, ascii="#"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $3F,$F0,  // 001111111111
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $3F,$F0,  // 001111111111
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=36, hex=$24, ascii="$"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $1F,$E0,  // 000111111110
       $1B,$60,  // 000110110110
       $33,$30,  // 001100110011
       $33,$00,  // 001100110000
       $1B,$00,  // 000110110000
       $1F,$00,  // 000111110000
       $07,$80,  // 000001111000
       $03,$E0,  // 000000111110
       $03,$60,  // 000000110110
       $03,$30,  // 000000110011
       $33,$30,  // 001100110011
       $1B,$60,  // 000110110110
       $1F,$E0,  // 000111111110
       $07,$80,  // 000001111000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=37, hex=$25, ascii="%"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $1C,$30,  // 000111000011
       $36,$60,  // 001101100110
       $36,$60,  // 001101100110
       $1C,$C0,  // 000111001100
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $18,$E0,  // 000110001110
       $19,$B0,  // 000110011011
       $31,$B0,  // 001100011011
       $30,$E0,  // 001100001110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=38, hex=$26, ascii="&"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0E,$00,  // 000011100000
       $1B,$00,  // 000110110000
       $31,$80,  // 001100011000
       $31,$80,  // 001100011000
       $31,$80,  // 001100011000
       $1B,$00,  // 000110110000
       $0E,$00,  // 000011100000
       $0C,$00,  // 000011000000
       $1E,$30,  // 000111100011
       $33,$30,  // 001100110011
       $31,$E0,  // 001100011110
       $30,$C0,  // 001100001100
       $31,$C0,  // 001100011100
       $33,$60,  // 001100110110
       $1E,$30,  // 000111100011
       $0C,$10,  // 000011000001
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=39, hex=$27, ascii="'"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=40, hex=$28, ascii="("

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=41, hex=$29, ascii=")"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=42, hex=$2A, ascii="*"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $18,$60,  // 000110000110
       $0C,$C0,  // 000011001100
       $07,$80,  // 000001111000
       $3F,$F0,  // 001111111111
       $07,$80,  // 000001111000
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=43, hex=$2B, ascii="+"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $3F,$F0,  // 001111111111
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=44, hex=$2C, ascii=","

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=45, hex=$2D, ascii="-"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=46, hex=$2E, ascii="."

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=47, hex=$2F, ascii="/"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$30,  // 000000000011
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=48, hex=$30, ascii="0"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=49, hex=$31, ascii="1"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $07,$00,  // 000001110000
       $0F,$00,  // 000011110000
       $1B,$00,  // 000110110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=50, hex=$32, ascii="2"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$60,  // 000000000110
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $18,$00,  // 000110000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=51, hex=$33, ascii="3"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$60,  // 000000000110
       $00,$C0,  // 000000001100
       $07,$C0,  // 000001111100
       $00,$C0,  // 000000001100
       $00,$60,  // 000000000110
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=52, hex=$34, ascii="4"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$C0,  // 000000001100
       $01,$C0,  // 000000011100
       $01,$C0,  // 000000011100
       $03,$C0,  // 000000111100
       $03,$C0,  // 000000111100
       $06,$C0,  // 000001101100
       $06,$C0,  // 000001101100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $18,$C0,  // 000110001100
       $18,$C0,  // 000110001100
       $30,$C0,  // 001100001100
       $3F,$F0,  // 001111111111
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=53, hex=$35, ascii="5"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $3F,$80,  // 001111111000
       $30,$E0,  // 001100001110
       $00,$60,  // 000000000110
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=54, hex=$36, ascii="6"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $01,$C0,  // 000000011100
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $3F,$80,  // 001111111000
       $38,$E0,  // 001110001110
       $30,$60,  // 001100000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=55, hex=$37, ascii="7"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=56, hex=$38, ascii="8"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $0C,$C0,  // 000011001100
       $0F,$C0,  // 000011111100
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=57, hex=$39, ascii="9"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$30,  // 000110000011
       $1C,$70,  // 000111000111
       $07,$F0,  // 000001111111
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $0E,$00,  // 000011100000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=58, hex=$3A, ascii=":"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$00,  // 000001110000
       $07,$00,  // 000001110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$00,  // 000001110000
       $07,$00,  // 000001110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=59, hex=$3B, ascii=";"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$00,  // 000001110000
       $07,$00,  // 000001110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$00,  // 000001110000
       $07,$00,  // 000001110000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=60, hex=$3C, ascii="<"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$30,  // 000000000011
       $00,$60,  // 000000000110
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $18,$00,  // 000110000000
       $30,$00,  // 001100000000
       $18,$00,  // 000110000000
       $0C,$00,  // 000011000000
       $06,$00,  // 000001100000
       $03,$00,  // 000000110000
       $01,$80,  // 000000011000
       $00,$C0,  // 000000001100
       $00,$60,  // 000000000110
       $00,$30,  // 000000000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=61, hex=$3D, ascii="="

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=62, hex=$3E, ascii=">"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$00,  // 001100000000
       $18,$00,  // 000110000000
       $0C,$00,  // 000011000000
       $06,$00,  // 000001100000
       $03,$00,  // 000000110000
       $01,$80,  // 000000011000
       $00,$C0,  // 000000001100
       $00,$60,  // 000000000110
       $00,$30,  // 000000000011
       $00,$60,  // 000000000110
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $18,$00,  // 000110000000
       $30,$00,  // 001100000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=63, hex=$3F, ascii="?"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$60,  // 000000000110
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=64, hex=$40, ascii="@"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $31,$F0,  // 001100011111
       $33,$70,  // 001100110111
       $36,$30,  // 001101100011
       $36,$30,  // 001101100011
       $36,$30,  // 001101100011
       $36,$30,  // 001101100011
       $33,$30,  // 001100110011
       $31,$F0,  // 001100011111
       $30,$00,  // 001100000000
       $18,$00,  // 000110000000
       $1C,$00,  // 000111000000
       $07,$F0,  // 000001111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=65, hex=$41, ascii="A"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $1F,$E0,  // 000111111110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=66, hex=$42, ascii="B"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$80,  // 001111111000
       $30,$E0,  // 001100001110
       $30,$60,  // 001100000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$60,  // 001100000110
       $30,$C0,  // 001100001100
       $3F,$C0,  // 001111111100
       $30,$C0,  // 001100001100
       $30,$60,  // 001100000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$60,  // 001100000110
       $30,$E0,  // 001100001110
       $3F,$80,  // 001111111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=67, hex=$43, ascii="C"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$C0,  // 000001111100
       $1C,$60,  // 000111000110
       $18,$30,  // 000110000011
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $18,$30,  // 000110000011
       $1C,$60,  // 000111000110
       $07,$C0,  // 000001111100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=68, hex=$44, ascii="D"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$80,  // 001111111000
       $30,$E0,  // 001100001110
       $30,$60,  // 001100000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$60,  // 001100000110
       $30,$E0,  // 001100001110
       $3F,$80,  // 001111111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=69, hex=$45, ascii="E"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $3F,$80,  // 001111111000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=70, hex=$46, ascii="F"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $3F,$80,  // 001111111000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=71, hex=$47, ascii="G"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$C0,  // 000001111100
       $1C,$60,  // 000111000110
       $18,$30,  // 000110000011
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $31,$F0,  // 001100011111
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$30,  // 000110000011
       $1C,$30,  // 000111000011
       $07,$F0,  // 000001111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=72, hex=$48, ascii="H"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $3F,$F0,  // 001111111111
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=73, hex=$49, ascii="I"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $1F,$E0,  // 000111111110
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $1F,$E0,  // 000111111110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=74, hex=$4A, ascii="J"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$F0,  // 000000111111
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $30,$C0,  // 001100001100
       $30,$C0,  // 001100001100
       $19,$80,  // 000110011000
       $1F,$80,  // 000111111000
       $06,$00,  // 000001100000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=75, hex=$4B, ascii="K"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$10,  // 001100000001
       $30,$30,  // 001100000011
       $30,$60,  // 001100000110
       $30,$C0,  // 001100001100
       $31,$80,  // 001100011000
       $33,$00,  // 001100110000
       $36,$00,  // 001101100000
       $3C,$00,  // 001111000000
       $38,$00,  // 001110000000
       $3C,$00,  // 001111000000
       $36,$00,  // 001101100000
       $33,$00,  // 001100110000
       $31,$80,  // 001100011000
       $30,$C0,  // 001100001100
       $30,$60,  // 001100000110
       $30,$30,  // 001100000011
       $30,$10,  // 001100000001
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=76, hex=$4C, ascii="L"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=77, hex=$4D, ascii="M"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $38,$70,  // 001110000111
       $3C,$F0,  // 001111001111
       $37,$B0,  // 001101111011
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=78, hex=$4E, ascii="N"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $38,$30,  // 001110000011
       $38,$30,  // 001110000011
       $3C,$30,  // 001111000011
       $3C,$30,  // 001111000011
       $36,$30,  // 001101100011
       $36,$30,  // 001101100011
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $31,$B0,  // 001100011011
       $31,$B0,  // 001100011011
       $30,$F0,  // 001100001111
       $30,$F0,  // 001100001111
       $30,$70,  // 001100000111
       $30,$70,  // 001100000111
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=79, hex=$4F, ascii="O"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=80, hex=$50, ascii="P"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$80,  // 001111111000
       $30,$E0,  // 001100001110
       $30,$60,  // 001100000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$60,  // 001100000110
       $30,$E0,  // 001100001110
       $3F,$80,  // 001111111000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=81, hex=$51, ascii="Q"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $31,$B0,  // 001100011011
       $18,$E0,  // 000110001110
       $1C,$E0,  // 000111001110
       $07,$B0,  // 000001111011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=82, hex=$52, ascii="R"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$80,  // 001111111000
       $30,$E0,  // 001100001110
       $30,$60,  // 001100000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$60,  // 001100000110
       $30,$E0,  // 001100001110
       $3F,$80,  // 001111111000
       $33,$00,  // 001100110000
       $33,$00,  // 001100110000
       $31,$80,  // 001100011000
       $30,$C0,  // 001100001100
       $30,$C0,  // 001100001100
       $30,$60,  // 001100000110
       $30,$60,  // 001100000110
       $30,$30,  // 001100000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=83, hex=$53, ascii="S"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $18,$00,  // 000110000000
       $1C,$00,  // 000111000000
       $07,$80,  // 000001111000
       $00,$E0,  // 000000001110
       $00,$60,  // 000000000110
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=84, hex=$54, ascii="T"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=85, hex=$55, ascii="U"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=86, hex=$56, ascii="V"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=87, hex=$57, ascii="W"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $3F,$F0,  // 001111111111
       $1C,$E0,  // 000111001110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=88, hex=$58, ascii="X"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=89, hex=$59, ascii="Y"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=90, hex=$5A, ascii="Z"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $30,$00,  // 001100000000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=91, hex=$5B, ascii="["

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $1F,$C0,  // 000111111100
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $1F,$C0,  // 000111111100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=92, hex=$5C, ascii="\"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$00,  // 001100000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=93, hex=$5D, ascii="]"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0F,$E0,  // 000011111110
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $0F,$E0,  // 000011111110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=94, hex=$5E, ascii="^"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=95, hex=$5F, ascii="_"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $FF,$F0,  // 111111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=96, hex=$60, ascii="`"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=97, hex=$61, ascii="a"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0F,$C0,  // 000011111100
       $18,$60,  // 000110000110
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $0F,$F0,  // 000011111111
       $18,$30,  // 000110000011
       $30,$30,  // 001100000011
       $30,$70,  // 001100000111
       $18,$F0,  // 000110001111
       $0F,$B0,  // 000011111011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=98, hex=$62, ascii="b"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $37,$80,  // 001101111000
       $3C,$E0,  // 001111001110
       $38,$60,  // 001110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $38,$60,  // 001110000110
       $3C,$E0,  // 001111001110
       $37,$80,  // 001101111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=99, hex=$63, ascii="c"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$C0,  // 000001111100
       $1C,$60,  // 000111000110
       $18,$30,  // 000110000011
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $18,$30,  // 000110000011
       $1C,$60,  // 000111000110
       $07,$C0,  // 000001111100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=100, hex=$64, ascii="d"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $07,$B0,  // 000001111011
       $1C,$F0,  // 000111001111
       $18,$70,  // 000110000111
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$70,  // 000110000111
       $1C,$F0,  // 000111001111
       $07,$B0,  // 000001111011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=101, hex=$65, ascii="e"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $3F,$F0,  // 001111111111
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $18,$30,  // 000110000011
       $1C,$60,  // 000111000110
       $07,$C0,  // 000001111100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=102, hex=$66, ascii="f"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $01,$E0,  // 000000011110
       $03,$30,  // 000000110011
       $03,$30,  // 000000110011
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $0F,$C0,  // 000011111100
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=103, hex=$67, ascii="g"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$B0,  // 000001111011
       $1C,$F0,  // 000111001111
       $18,$70,  // 000110000111
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$70,  // 000110000111
       $1C,$F0,  // 000111001111
       $07,$B0,  // 000001111011
       $00,$30,  // 000000000011
       $30,$60,  // 001100000110
       $18,$E0,  // 000110001110
       $0F,$80,  // 000011111000

       //
        // code=104, hex=$68, ascii="h"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $37,$80,  // 001101111000
       $3C,$E0,  // 001111001110
       $38,$60,  // 001110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=105, hex=$69, ascii="i"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$00,  // 000001110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $0F,$C0,  // 000011111100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=106, hex=$6A, ascii="j"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$80,  // 000000111000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $31,$80,  // 001100011000
       $31,$80,  // 001100011000
       $1B,$80,  // 000110111000
       $0F,$00,  // 000011110000

       //
        // code=107, hex=$6B, ascii="k"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$30,  // 001100000011
       $30,$60,  // 001100000110
       $30,$C0,  // 001100001100
       $31,$80,  // 001100011000
       $33,$00,  // 001100110000
       $36,$00,  // 001101100000
       $3F,$00,  // 001111110000
       $39,$80,  // 001110011000
       $30,$C0,  // 001100001100
       $30,$60,  // 001100000110
       $30,$30,  // 001100000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=108, hex=$6C, ascii="l"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$80,  // 000000111000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $07,$E0,  // 000001111110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=109, hex=$6D, ascii="m"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $36,$C0,  // 001101101100
       $3F,$E0,  // 001111111110
       $3B,$70,  // 001110110111
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=110, hex=$6E, ascii="n"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $37,$80,  // 001101111000
       $3C,$E0,  // 001111001110
       $38,$60,  // 001110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=111, hex=$6F, ascii="o"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=112, hex=$70, ascii="p"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $37,$80,  // 001101111000
       $3C,$E0,  // 001111001110
       $38,$60,  // 001110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $38,$60,  // 001110000110
       $3C,$E0,  // 001111001110
       $37,$80,  // 001101111000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000

       //
        // code=113, hex=$71, ascii="q"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$B0,  // 000001111011
       $1C,$F0,  // 000111001111
       $18,$70,  // 000110000111
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$70,  // 000110000111
       $1C,$F0,  // 000111001111
       $07,$B0,  // 000001111011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011

       //
        // code=114, hex=$72, ascii="r"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $37,$C0,  // 001101111100
       $3C,$60,  // 001111000110
       $38,$30,  // 001110000011
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=115, hex=$73, ascii="s"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0F,$C0,  // 000011111100
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$00,  // 001100000000
       $18,$00,  // 000110000000
       $0F,$C0,  // 000011111100
       $00,$60,  // 000000000110
       $00,$30,  // 000000000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $0F,$C0,  // 000011111100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=116, hex=$74, ascii="t"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $1F,$80,  // 000111111000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$60,  // 000001100110
       $06,$60,  // 000001100110
       $03,$C0,  // 000000111100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=117, hex=$75, ascii="u"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$70,  // 000110000111
       $1C,$F0,  // 000111001111
       $07,$B0,  // 000001111011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=118, hex=$76, ascii="v"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=119, hex=$77, ascii="w"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $3F,$F0,  // 001111111111
       $1C,$E0,  // 000111001110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=120, hex=$78, ascii="x"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $0C,$C0,  // 000011001100
       $07,$80,  // 000001111000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=121, hex=$79, ascii="y"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$70,  // 000110000111
       $1C,$F0,  // 000111001111
       $07,$B0,  // 000001111011
       $00,$30,  // 000000000011
       $30,$60,  // 001100000110
       $18,$E0,  // 000110001110
       $0F,$80,  // 000011111000

       //
        // code=122, hex=$7A, ascii="z"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $00,$30,  // 000000000011
       $00,$60,  // 000000000110
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $18,$00,  // 000110000000
       $30,$00,  // 001100000000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=123, hex=$7B, ascii="{"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$E0,  // 000000001110
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $06,$00,  // 000001100000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $01,$80,  // 000000011000
       $00,$E0,  // 000000001110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=124, hex=$7C, ascii="|"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=125, hex=$7D, ascii="}"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0E,$00,  // 000011100000
       $03,$00,  // 000000110000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $00,$C0,  // 000000001100
       $00,$60,  // 000000000110
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $0E,$00,  // 000011100000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=126, hex=$7E, ascii="~"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $1C,$00,  // 000111000000
       $36,$30,  // 001101100011
       $63,$60,  // 011000110110
       $01,$C0,  // 000000011100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=127, hex=$7F, ascii="^?"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=128, hex=$80, ascii="!^@"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$C0,  // 000001111100
       $1C,$60,  // 000111000110
       $18,$30,  // 000110000011
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $18,$30,  // 000110000011
       $1C,$60,  // 000111000110
       $07,$C0,  // 000001111100
       $01,$80,  // 000000011000
       $00,$C0,  // 000000001100
       $18,$C0,  // 000110001100
       $0F,$80,  // 000011111000

       //
        // code=129, hex=$81, ascii="!^A"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$70,  // 000110000111
       $1C,$F0,  // 000111001111
       $07,$B0,  // 000001111011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=130, hex=$82, ascii="!^B"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $3F,$F0,  // 001111111111
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $18,$30,  // 000110000011
       $1C,$60,  // 000111000110
       $07,$C0,  // 000001111100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=131, hex=$83, ascii="!^C"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0F,$C0,  // 000011111100
       $18,$60,  // 000110000110
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $0F,$F0,  // 000011111111
       $18,$30,  // 000110000011
       $30,$30,  // 001100000011
       $30,$70,  // 001100000111
       $18,$F0,  // 000110001111
       $0F,$B0,  // 000011111011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=132, hex=$84, ascii="!^D"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0F,$C0,  // 000011111100
       $18,$60,  // 000110000110
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $0F,$F0,  // 000011111111
       $18,$30,  // 000110000011
       $30,$30,  // 001100000011
       $30,$70,  // 001100000111
       $18,$F0,  // 000110001111
       $0F,$B0,  // 000011111011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=133, hex=$85, ascii="!^E"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$00,  // 000011000000
       $06,$00,  // 000001100000
       $03,$00,  // 000000110000
       $01,$80,  // 000000011000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0F,$C0,  // 000011111100
       $18,$60,  // 000110000110
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $0F,$F0,  // 000011111111
       $18,$30,  // 000110000011
       $30,$30,  // 001100000011
       $30,$70,  // 001100000111
       $18,$F0,  // 000110001111
       $0F,$B0,  // 000011111011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=134, hex=$86, ascii="!^F"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $0C,$C0,  // 000011001100
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $0F,$C0,  // 000011111100
       $18,$60,  // 000110000110
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $0F,$F0,  // 000011111111
       $18,$30,  // 000110000011
       $30,$30,  // 001100000011
       $30,$70,  // 001100000111
       $18,$F0,  // 000110001111
       $0F,$B0,  // 000011111011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=135, hex=$87, ascii="!^G"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$C0,  // 000001111100
       $1C,$60,  // 000111000110
       $18,$30,  // 000110000011
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $18,$30,  // 000110000011
       $1C,$60,  // 000111000110
       $07,$C0,  // 000001111100
       $01,$80,  // 000000011000
       $00,$C0,  // 000000001100
       $18,$C0,  // 000110001100
       $0F,$80,  // 000011111000

       //
        // code=136, hex=$88, ascii="!^H"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $3F,$F0,  // 001111111111
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $18,$30,  // 000110000011
       $1C,$60,  // 000111000110
       $07,$C0,  // 000001111100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=137, hex=$89, ascii="!^I"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $3F,$F0,  // 001111111111
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $18,$30,  // 000110000011
       $1C,$60,  // 000111000110
       $07,$C0,  // 000001111100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=138, hex=$8A, ascii="!^J"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$00,  // 000011000000
       $06,$00,  // 000001100000
       $03,$00,  // 000000110000
       $01,$80,  // 000000011000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $3F,$F0,  // 001111111111
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $18,$30,  // 000110000011
       $1C,$60,  // 000111000110
       $07,$C0,  // 000001111100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=139, hex=$8B, ascii="!^K"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$00,  // 000001110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $0F,$C0,  // 000011111100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=140, hex=$8C, ascii="!^L"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$00,  // 000001110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $0F,$C0,  // 000011111100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=141, hex=$8D, ascii="!^M"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$00,  // 000011000000
       $06,$00,  // 000001100000
       $03,$00,  // 000000110000
       $01,$80,  // 000000011000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$00,  // 000001110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $0F,$C0,  // 000011111100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=142, hex=$8E, ascii="!^N"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $1F,$E0,  // 000111111110
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=143, hex=$8F, ascii="!^O"

       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $0C,$C0,  // 000011001100
       $07,$80,  // 000001111000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $1F,$E0,  // 000111111110
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=144, hex=$90, ascii="!^P"

       $00,$00,  // 000000000000
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $3F,$F0,  // 001111111111
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $3F,$80,  // 001111111000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=145, hex=$91, ascii="!^Q"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $1C,$E0,  // 000111001110
       $37,$B0,  // 001101111011
       $03,$30,  // 000000110011
       $03,$30,  // 000000110011
       $03,$30,  // 000000110011
       $1F,$E0,  // 000111111110
       $33,$00,  // 001100110000
       $33,$00,  // 001100110000
       $33,$00,  // 001100110000
       $37,$B0,  // 001101111011
       $1E,$E0,  // 000111101110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=146, hex=$92, ascii="!^R"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $01,$F0,  // 000000011111
       $01,$80,  // 000000011000
       $03,$80,  // 000000111000
       $03,$80,  // 000000111000
       $03,$80,  // 000000111000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $05,$80,  // 000001011000
       $0D,$E0,  // 000011011110
       $0D,$80,  // 000011011000
       $0F,$80,  // 000011111000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $31,$80,  // 001100011000
       $31,$80,  // 001100011000
       $31,$F0,  // 001100011111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=147, hex=$93, ascii="!^S"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=148, hex=$94, ascii="!^T"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=149, hex=$95, ascii="!^U"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$00,  // 000011000000
       $06,$00,  // 000001100000
       $03,$00,  // 000000110000
       $01,$80,  // 000000011000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=150, hex=$96, ascii="!^V"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$70,  // 000110000111
       $1C,$F0,  // 000111001111
       $07,$B0,  // 000001111011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=151, hex=$97, ascii="!^W"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$00,  // 000011000000
       $06,$00,  // 000001100000
       $03,$00,  // 000000110000
       $01,$80,  // 000000011000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$70,  // 000110000111
       $1C,$F0,  // 000111001111
       $07,$B0,  // 000001111011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=152, hex=$98, ascii="!^X"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$70,  // 000110000111
       $1C,$F0,  // 000111001111
       $07,$B0,  // 000001111011
       $00,$30,  // 000000000011
       $30,$60,  // 001100000110
       $18,$E0,  // 000110001110
       $0F,$80,  // 000011111000

       //
        // code=153, hex=$99, ascii="!^Y"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=154, hex=$9A, ascii="!^Z"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=155, hex=$9B, ascii="!^["

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $07,$C0,  // 000001111100
       $1C,$60,  // 000111000110
       $18,$30,  // 000110000011
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $18,$30,  // 000110000011
       $1C,$60,  // 000111000110
       $07,$C0,  // 000001111100
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=156, hex=$9C, ascii="!^\"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$E0,  // 000000111110
       $06,$30,  // 000001100011
       $06,$30,  // 000001100011
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $1F,$80,  // 000111111000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $1E,$00,  // 000111100000
       $1F,$F0,  // 000111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=157, hex=$9D, ascii="!^]"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $03,$00,  // 000000110000
       $1F,$E0,  // 000111111110
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $1F,$E0,  // 000111111110
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=158, hex=$9E, ascii="!^^"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$80,  // 001111111000
       $30,$E0,  // 001100001110
       $30,$60,  // 001100000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$60,  // 001100000110
       $30,$E0,  // 001100001110
       $3F,$80,  // 001111111000
       $30,$80,  // 001100001000
       $31,$80,  // 001100011000
       $37,$E0,  // 001101111110
       $31,$80,  // 001100011000
       $31,$80,  // 001100011000
       $31,$80,  // 001100011000
       $31,$B0,  // 001100011011
       $30,$E0,  // 001100001110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=159, hex=$9F, ascii="!^_"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $01,$E0,  // 000000011110
       $03,$30,  // 000000110011
       $03,$30,  // 000000110011
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $0F,$C0,  // 000011111100
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $33,$00,  // 001100110000
       $33,$00,  // 001100110000
       $1E,$00,  // 000111100000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=160, hex=$A0, ascii="! "

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0F,$C0,  // 000011111100
       $18,$60,  // 000110000110
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $0F,$F0,  // 000011111111
       $18,$30,  // 000110000011
       $30,$30,  // 001100000011
       $30,$70,  // 001100000111
       $18,$F0,  // 000110001111
       $0F,$B0,  // 000011111011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=161, hex=$A1, ascii="!!"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$00,  // 000001110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $0F,$C0,  // 000011111100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=162, hex=$A2, ascii="!""

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=163, hex=$A3, ascii="!#"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$70,  // 000110000111
       $1C,$F0,  // 000111001111
       $07,$B0,  // 000001111011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=164, hex=$A4, ascii="!$"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $1C,$00,  // 000111000000
       $36,$30,  // 001101100011
       $63,$60,  // 011000110110
       $01,$C0,  // 000000011100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $37,$80,  // 001101111000
       $3C,$E0,  // 001111001110
       $38,$60,  // 001110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=165, hex=$A5, ascii="!%"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $1C,$00,  // 000111000000
       $36,$30,  // 001101100011
       $63,$60,  // 011000110110
       $01,$C0,  // 000000011100
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $38,$30,  // 001110000011
       $3C,$30,  // 001111000011
       $36,$30,  // 001101100011
       $33,$30,  // 001100110011
       $31,$B0,  // 001100011011
       $30,$F0,  // 001100001111
       $30,$70,  // 001100000111
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=166, hex=$A6, ascii="!&"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0E,$80,  // 000011101000
       $1B,$80,  // 000110111000
       $31,$80,  // 001100011000
       $31,$80,  // 001100011000
       $1B,$80,  // 000110111000
       $0E,$C0,  // 000011101100
       $00,$00,  // 000000000000
       $3F,$C0,  // 001111111100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=167, hex=$A7, ascii="!'"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0F,$00,  // 000011110000
       $19,$80,  // 000110011000
       $30,$C0,  // 001100001100
       $30,$C0,  // 001100001100
       $19,$80,  // 000110011000
       $0F,$00,  // 000011110000
       $00,$00,  // 000000000000
       $3F,$C0,  // 001111111100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=168, hex=$A8, ascii="!("

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $18,$00,  // 000110000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=169, hex=$A9, ascii="!)"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0F,$F0,  // 000011111111
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=170, hex=$AA, ascii="!*"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0F,$F0,  // 000011111111
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$30,  // 000000000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=171, hex=$AB, ascii="!+"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $18,$30,  // 000110000011
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $18,$C0,  // 000110001100
       $18,$C0,  // 000110001100
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $06,$E0,  // 000001101110
       $0D,$B0,  // 000011011011
       $0C,$30,  // 000011000011
       $18,$60,  // 000110000110
       $18,$C0,  // 000110001100
       $31,$80,  // 001100011000
       $31,$F0,  // 001100011111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=172, hex=$AC, ascii="!,"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $18,$30,  // 000110000011
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $18,$C0,  // 000110001100
       $18,$C0,  // 000110001100
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $06,$60,  // 000001100110
       $06,$E0,  // 000001101110
       $0D,$E0,  // 000011011110
       $0D,$60,  // 000011010110
       $1B,$60,  // 000110110110
       $1B,$F0,  // 000110111111
       $30,$60,  // 001100000110
       $30,$60,  // 001100000110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=173, hex=$AD, ascii="!-"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=174, hex=$AE, ascii="!."

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$30,  // 000000110011
       $06,$60,  // 000001100110
       $0C,$C0,  // 000011001100
       $19,$80,  // 000110011000
       $33,$00,  // 001100110000
       $19,$80,  // 000110011000
       $0C,$C0,  // 000011001100
       $06,$60,  // 000001100110
       $03,$30,  // 000000110011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=175, hex=$AF, ascii="!/"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $33,$00,  // 001100110000
       $19,$80,  // 000110011000
       $0C,$C0,  // 000011001100
       $06,$60,  // 000001100110
       $03,$30,  // 000000110011
       $06,$60,  // 000001100110
       $0C,$C0,  // 000011001100
       $19,$80,  // 000110011000
       $33,$00,  // 001100110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=176, hex=$B0, ascii="!0"

       $22,$20,  // 001000100010
       $88,$80,  // 100010001000
       $22,$20,  // 001000100010
       $88,$80,  // 100010001000
       $22,$20,  // 001000100010
       $88,$80,  // 100010001000
       $22,$20,  // 001000100010
       $88,$80,  // 100010001000
       $22,$20,  // 001000100010
       $88,$80,  // 100010001000
       $22,$20,  // 001000100010
       $88,$80,  // 100010001000
       $22,$20,  // 001000100010
       $88,$80,  // 100010001000
       $22,$20,  // 001000100010
       $88,$80,  // 100010001000
       $22,$20,  // 001000100010
       $88,$80,  // 100010001000
       $22,$20,  // 001000100010
       $88,$80,  // 100010001000
       $22,$20,  // 001000100010
       $88,$80,  // 100010001000
       $22,$20,  // 001000100010
       $88,$80,  // 100010001000

       //
        // code=177, hex=$B1, ascii="!1"

       $55,$50,  // 010101010101
       $AA,$A0,  // 101010101010
       $55,$50,  // 010101010101
       $AA,$A0,  // 101010101010
       $55,$50,  // 010101010101
       $AA,$A0,  // 101010101010
       $55,$50,  // 010101010101
       $AA,$A0,  // 101010101010
       $55,$50,  // 010101010101
       $AA,$A0,  // 101010101010
       $55,$50,  // 010101010101
       $AA,$A0,  // 101010101010
       $55,$50,  // 010101010101
       $AA,$A0,  // 101010101010
       $55,$50,  // 010101010101
       $AA,$A0,  // 101010101010
       $55,$50,  // 010101010101
       $AA,$A0,  // 101010101010
       $55,$50,  // 010101010101
       $AA,$A0,  // 101010101010
       $55,$50,  // 010101010101
       $AA,$A0,  // 101010101010
       $55,$50,  // 010101010101
       $AA,$A0,  // 101010101010

       //
        // code=178, hex=$B2, ascii="!2"

       $77,$70,  // 011101110111
       $DD,$D0,  // 110111011101
       $77,$70,  // 011101110111
       $DD,$D0,  // 110111011101
       $77,$70,  // 011101110111
       $DD,$D0,  // 110111011101
       $77,$70,  // 011101110111
       $DD,$D0,  // 110111011101
       $77,$70,  // 011101110111
       $DD,$D0,  // 110111011101
       $77,$70,  // 011101110111
       $DD,$D0,  // 110111011101
       $77,$70,  // 011101110111
       $DD,$D0,  // 110111011101
       $77,$70,  // 011101110111
       $DD,$D0,  // 110111011101
       $77,$70,  // 011101110111
       $DD,$D0,  // 110111011101
       $77,$70,  // 011101110111
       $DD,$D0,  // 110111011101
       $77,$70,  // 011101110111
       $DD,$D0,  // 110111011101
       $77,$70,  // 011101110111
       $DD,$D0,  // 110111011101

       //
        // code=179, hex=$B3, ascii="!3"

       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000

       //
        // code=180, hex=$B4, ascii="!4"

       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $FE,$00,  // 111111100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000

       //
        // code=181, hex=$B5, ascii="!5"

       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $FE,$00,  // 111111100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $FE,$00,  // 111111100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000

       //
        // code=182, hex=$B6, ascii="!6"

       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $F9,$80,  // 111110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000

       //
        // code=183, hex=$B7, ascii="!7"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $FF,$80,  // 111111111000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000

       //
        // code=184, hex=$B8, ascii="!8"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $FE,$00,  // 111111100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $FE,$00,  // 111111100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000

       //
        // code=185, hex=$B9, ascii="!9"

       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $F9,$80,  // 111110011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $F9,$80,  // 111110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000

       //
        // code=186, hex=$BA, ascii="!:"

       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000

       //
        // code=187, hex=$BB, ascii="!;"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $FF,$80,  // 111111111000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $F9,$80,  // 111110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000

       //
        // code=188, hex=$BC, ascii="!<"

       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $F9,$80,  // 111110011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $FF,$80,  // 111111111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=189, hex=$BD, ascii="!="

       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $FF,$80,  // 111111111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=190, hex=$BE, ascii="!>"

       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $FE,$00,  // 111111100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $FE,$00,  // 111111100000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=191, hex=$BF, ascii="!?"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $FE,$00,  // 111111100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000

       //
        // code=192, hex=$C0, ascii="!@"

       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $07,$F0,  // 000001111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=193, hex=$C1, ascii="!A"

       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $FF,$F0,  // 111111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=194, hex=$C2, ascii="!B"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $FF,$F0,  // 111111111111
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000

       //
        // code=195, hex=$C3, ascii="!C"

       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $07,$F0,  // 000001111111
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000

       //
        // code=196, hex=$C4, ascii="!D"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $FF,$F0,  // 111111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=197, hex=$C5, ascii="!E"

       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $FF,$F0,  // 111111111111
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000

       //
        // code=198, hex=$C6, ascii="!F"

       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $07,$F0,  // 000001111111
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $07,$F0,  // 000001111111
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000

       //
        // code=199, hex=$C7, ascii="!G"

       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$F0,  // 000110011111
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000

       //
        // code=200, hex=$C8, ascii="!H"

       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$F0,  // 000110011111
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $1F,$F0,  // 000111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=201, hex=$C9, ascii="!I"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $1F,$F0,  // 000111111111
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $19,$F0,  // 000110011111
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000

       //
        // code=202, hex=$CA, ascii="!J"

       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $F9,$F0,  // 111110011111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $FF,$F0,  // 111111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=203, hex=$CB, ascii="!K"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $FF,$F0,  // 111111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $F9,$F0,  // 111110011111
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000

       //
        // code=204, hex=$CC, ascii="!L"

       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$F0,  // 000110011111
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $19,$F0,  // 000110011111
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000

       //
        // code=205, hex=$CD, ascii="!M"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $FF,$F0,  // 111111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $FF,$F0,  // 111111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=206, hex=$CE, ascii="!N"

       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $F9,$F0,  // 111110011111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $F9,$F0,  // 111110011111
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000

       //
        // code=207, hex=$CF, ascii="!O"

       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $FF,$F0,  // 111111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $FF,$F0,  // 111111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=208, hex=$D0, ascii="!P"

       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $FF,$F0,  // 111111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=209, hex=$D1, ascii="!Q"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $FF,$F0,  // 111111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $FF,$F0,  // 111111111111
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000

       //
        // code=210, hex=$D2, ascii="!R"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $FF,$F0,  // 111111111111
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000

       //
        // code=211, hex=$D3, ascii="!S"

       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $1F,$F0,  // 000111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=212, hex=$D4, ascii="!T"

       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $07,$F0,  // 000001111111
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $07,$F0,  // 000001111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=213, hex=$D5, ascii="!U"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$F0,  // 000001111111
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $07,$F0,  // 000001111111
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000

       //
        // code=214, hex=$D6, ascii="!V"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $1F,$F0,  // 000111111111
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000

       //
        // code=215, hex=$D7, ascii="!W"

       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $FF,$F0,  // 111111111111
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000
       $19,$80,  // 000110011000

       //
        // code=216, hex=$D8, ascii="!X"

       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $FF,$F0,  // 111111111111
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $FF,$F0,  // 111111111111
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000

       //
        // code=217, hex=$D9, ascii="!Y"

       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $FE,$00,  // 111111100000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=218, hex=$DA, ascii="!Z"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$F0,  // 000001111111
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000

       //
        // code=219, hex=$DB, ascii="!["

       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111

       //
        // code=220, hex=$DC, ascii="!\"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111

       //
        // code=221, hex=$DD, ascii="!]"

       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000
       $FC,$00,  // 111111000000

       //
        // code=222, hex=$DE, ascii="!^"

       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111
       $03,$F0,  // 000000111111

       //
        // code=223, hex=$DF, ascii="!_"

       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $FF,$F0,  // 111111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=224, hex=$E0, ascii="!`"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0F,$30,  // 000011110011
       $19,$E0,  // 000110011110
       $30,$C0,  // 001100001100
       $30,$C0,  // 001100001100
       $30,$C0,  // 001100001100
       $30,$C0,  // 001100001100
       $30,$C0,  // 001100001100
       $30,$C0,  // 001100001100
       $30,$C0,  // 001100001100
       $19,$E0,  // 000110011110
       $0F,$30,  // 000011110011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=225, hex=$E1, ascii="!a"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$60,  // 001100000110
       $30,$C0,  // 001100001100
       $37,$C0,  // 001101111100
       $30,$C0,  // 001100001100
       $30,$60,  // 001100000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$60,  // 001100000110
       $30,$E0,  // 001100001110
       $37,$80,  // 001101111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=226, hex=$E2, ascii="!b"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=227, hex=$E3, ascii="!c"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0E,$30,  // 000011100011
       $3F,$E0,  // 001111111110
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=228, hex=$E4, ascii="!d"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $30,$30,  // 001100000011
       $18,$30,  // 000110000011
       $18,$00,  // 000110000000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $18,$00,  // 000110000000
       $18,$30,  // 000110000011
       $30,$30,  // 001100000011
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=229, hex=$E5, ascii="!e"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$F0,  // 000001111111
       $1D,$C0,  // 000111011100
       $18,$C0,  // 000110001100
       $30,$60,  // 001100000110
       $30,$60,  // 001100000110
       $30,$60,  // 001100000110
       $30,$60,  // 001100000110
       $30,$60,  // 001100000110
       $18,$C0,  // 000110001100
       $1D,$C0,  // 000111011100
       $07,$00,  // 000001110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=230, hex=$E6, ascii="!f"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $18,$30,  // 000110000011
       $18,$30,  // 000110000011
       $18,$30,  // 000110000011
       $18,$30,  // 000110000011
       $18,$30,  // 000110000011
       $18,$30,  // 000110000011
       $18,$30,  // 000110000011
       $18,$30,  // 000110000011
       $1C,$60,  // 000111000110
       $1E,$E0,  // 000111101110
       $1B,$80,  // 000110111000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $38,$00,  // 001110000000
       $30,$00,  // 001100000000

       //
        // code=231, hex=$E7, ascii="!g"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $0C,$C0,  // 000011001100
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=232, hex=$E8, ascii="!h"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $0F,$C0,  // 000011111100
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $0F,$C0,  // 000011111100
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=233, hex=$E9, ascii="!i"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $3F,$F0,  // 001111111111
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $1C,$E0,  // 000111001110
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=234, hex=$EA, ascii="!j"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $0C,$C0,  // 000011001100
       $3C,$F0,  // 001111001111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=235, hex=$EB, ascii="!k"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$C0,  // 000000111100
       $06,$70,  // 000001100111
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $06,$00,  // 000001100000
       $03,$00,  // 000000110000
       $07,$80,  // 000001111000
       $0C,$C0,  // 000011001100
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $18,$60,  // 000110000110
       $0C,$C0,  // 000011001100
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=236, hex=$EC, ascii="!l"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $1C,$E0,  // 000111001110
       $37,$B0,  // 001101111011
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $37,$B0,  // 001101111011
       $1C,$E0,  // 000111001110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=237, hex=$ED, ascii="!m"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$30,  // 000000000011
       $00,$60,  // 000000000110
       $00,$60,  // 000000000110
       $00,$C0,  // 000000001100
       $0F,$C0,  // 000011111100
       $19,$E0,  // 000110011110
       $31,$B0,  // 001100011011
       $33,$30,  // 001100110011
       $33,$30,  // 001100110011
       $36,$30,  // 001101100011
       $1E,$60,  // 000111100110
       $0F,$C0,  // 000011111100
       $0C,$00,  // 000011000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $30,$00,  // 001100000000
       $30,$00,  // 001100000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=238, hex=$EE, ascii="!n"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $01,$E0,  // 000000011110
       $07,$00,  // 000001110000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $1F,$C0,  // 000111111100
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $0C,$00,  // 000011000000
       $0C,$00,  // 000011000000
       $06,$00,  // 000001100000
       $07,$00,  // 000001110000
       $01,$E0,  // 000000011110
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=239, hex=$EF, ascii="!o"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $1C,$E0,  // 000111001110
       $18,$60,  // 000110000110
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $30,$30,  // 001100000011
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=240, hex=$F0, ascii="!p"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=241, hex=$F1, ascii="!q"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $3F,$F0,  // 001111111111
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=242, hex=$F2, ascii="!r"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0C,$00,  // 000011000000
       $06,$00,  // 000001100000
       $03,$00,  // 000000110000
       $01,$80,  // 000000011000
       $00,$C0,  // 000000001100
       $00,$60,  // 000000000110
       $00,$30,  // 000000000011
       $00,$60,  // 000000000110
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=243, hex=$F3, ascii="!s"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $18,$00,  // 000110000000
       $30,$00,  // 001100000000
       $18,$00,  // 000110000000
       $0C,$00,  // 000011000000
       $06,$00,  // 000001100000
       $03,$00,  // 000000110000
       $01,$80,  // 000000011000
       $00,$C0,  // 000000001100
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=244, hex=$F4, ascii="!t"

       $03,$C0,  // 000000111100
       $06,$60,  // 000001100110
       $06,$60,  // 000001100110
       $06,$60,  // 000001100110
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000

       //
        // code=245, hex=$F5, ascii="!u"

       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $06,$00,  // 000001100000
       $66,$00,  // 011001100000
       $66,$00,  // 011001100000
       $66,$00,  // 011001100000
       $3C,$00,  // 001111000000

       //
        // code=246, hex=$F6, ascii="!v"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$F0,  // 001111111111
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=247, hex=$F7, ascii="!w"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $1C,$00,  // 000111000000
       $36,$30,  // 001101100011
       $63,$60,  // 011000110110
       $01,$C0,  // 000000011100
       $1C,$00,  // 000111000000
       $36,$30,  // 001101100011
       $63,$60,  // 011000110110
       $01,$C0,  // 000000011100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=248, hex=$F8, ascii="!x"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0F,$00,  // 000011110000
       $19,$80,  // 000110011000
       $30,$C0,  // 001100001100
       $30,$C0,  // 001100001100
       $19,$80,  // 000110011000
       $0F,$00,  // 000011110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=249, hex=$F9, ascii="!y"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=250, hex=$FA, ascii="!z"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $07,$80,  // 000001111000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=251, hex=$FB, ascii="!{"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$F0,  // 000000001111
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $00,$C0,  // 000000001100
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $01,$80,  // 000000011000
       $03,$00,  // 000000110000
       $03,$00,  // 000000110000
       $C3,$00,  // 110000110000
       $C6,$00,  // 110001100000
       $66,$00,  // 011001100000
       $66,$00,  // 011001100000
       $24,$00,  // 001001000000
       $3C,$00,  // 001111000000
       $3C,$00,  // 001111000000
       $18,$00,  // 000110000000
       $18,$00,  // 000110000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=252, hex=$FC, ascii="!|"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $3F,$00,  // 001111110000
       $39,$80,  // 001110011000
       $31,$80,  // 001100011000
       $31,$80,  // 001100011000
       $31,$80,  // 001100011000
       $31,$80,  // 001100011000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=253, hex=$FD, ascii="!}"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $1E,$00,  // 000111100000
       $33,$00,  // 001100110000
       $06,$00,  // 000001100000
       $0C,$00,  // 000011000000
       $18,$00,  // 000110000000
       $3F,$00,  // 001111110000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=254, hex=$FE, ascii="!~"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $0F,$C0,  // 000011111100
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000

       //
        // code=255, hex=$FF, ascii="!^"

       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00,  // 000000000000
       $00,$00   // 000000000000
   );

implementation

end.

